import sys
import os
import matplotlib.pyplot as plt

globalTime = 0
deltaTime = 0

filename=sys.argv[1]
basename=os.path.splitext(filename)[0]
print(filename)

memcpy_times = {"tcm_2_dram" : [], \
				"dram_2_dram": [], \
				"tcm_2_ocm"  : [], \
				"ocm_2_ocm"  : [], \
				"ocm_2_dram" : [] }

lineNr=0
globalTs = {}	

def parseLine(hookID, value, deltaTime, globalTime):
	global memcpy_times
	int_value = int(value,16)
	
	if(hookID == "2000"):
		globalTs["startMemcpy"] = globalTime
	if(hookID == "2001"):
		memcpy_times["tcm_2_dram"].append(globalTime - globalTs["startMemcpy"])
	if(hookID == "2002"):
		memcpy_times["dram_2_dram"].append(globalTime - globalTs["startMemcpy"])
	if(hookID == "2003"):
		memcpy_times["tcm_2_ocm"].append(globalTime - globalTs["startMemcpy"])
	if(hookID == "2004"):
		memcpy_times["ocm_2_ocm"].append(globalTime - globalTs["startMemcpy"])	
	if(hookID == "2005"):
		memcpy_times["ocm_2_dram"].append(globalTime - globalTs["startMemcpy"])


with open(filename) as f:
	lineNr = 1
	for line in f:
		if(line.startswith("-")):
			lis = line.split()
			if(len(lis) > 3):			
				if(lineNr > 1):
					deltaTime = int('{:.9f}'.format(float(lis[3])).replace('.', ''));
					globalTime = globalTime + deltaTime
				parseLine(lis[1],lis[2], deltaTime, globalTime)
				lineNr = lineNr +1
	
	
	plt.plot(memcpy_times["tcm_2_dram"], label="tcm_2_dram")
	plt.plot(memcpy_times["dram_2_dram"], label="dram_2_dram")
	plt.plot(memcpy_times["tcm_2_ocm"], label="tcm_2_ocm")
	plt.plot(memcpy_times["ocm_2_ocm"], label="ocm_2_ocm")
	plt.plot(memcpy_times["ocm_2_dram"], label="ocm_2_dram")
	plt.legend()
	plt.xlabel("Test Run")
	plt.ylabel("Latency [ns]")
	plt.title("memcpy of 64kB memory block")
	plt.ylim(bottom=0)
	plt.grid()
	plt.show()

	
	quit()
